import { readFileSync, writeFileSync } from "fs";
import path from "path";

export const state = new Proxy<{
	explodesAt: number;
	accessToken: string;
	refreshToken: string;
}>(JSON.parse(readFileSync(path.join(__dirname, "../state.json"), "utf-8")), {
	get(target, prop) {
		const data = readFileSync(
			path.join(__dirname, "../state.json"),
			"utf-8"
		);
		return JSON.parse(data)[prop];
	},
	set(target, prop, value) {
		const data = JSON.parse(
			readFileSync(path.join(__dirname, "../state.json"), "utf-8")
		);
		data[prop] = value;
		writeFileSync(
			path.join(__dirname, "../state.json"),
			JSON.stringify(data)
		);
		return true;
	}
});
